-----------------------------------------------------------------------------------------------
-- Client Lua Script for ChoicesHelper
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- ChoicesHelper Module Definition
-----------------------------------------------------------------------------------------------
local ChoicesHelper = {} 
local GeminiDB

-----------------------------------------------------------------------------------------------
-- Version
-----------------------------------------------------------------------------------------------

ChoicesHelper.VERSION = 9.3
ChoicesHelper.VERSIONNOTES = {
	[5] = {
		"Can now export specialization",
		"Can now import specialization",
		"Cancel button to all the pop up windows"
		},
	[6] = {
		"The 'Copy to Clipboard' button is working !",
		"Move a little bit the close button of the main window for nicer design."
	},
	[7] = {
		"Clean up the code",
		"Add a total gear score into the character page. Check it out !"
	},
	[7.5] = {
		"Add an option to display score on all item",
		"Can now type '.', it will turn into '0.' to type decimal faster"
	},
	[7.6] = {
		"Fix a typo."
	},
	[7.7] = {
		"Fix a bug when you open the character page before the /chs menu."
	},
	[7.8] = {
		"Fix a bug in the import function."
	},
	[8] = {
		"Can use /chs [SPEC NAME] to switch specialization with macro !",
		"New window in the character window to have a better display.",
		"In this new window, you can see base Damage, base Heal, damage to death values."
	},
	[9] = {
		"Work with CharacterInfoPlus addon: http://www.curse.com/ws-addons/wildstar/222978-characterinfoplus"
	},
	[9.2] = {
		"Update the link the the CharacterInfoPlus library"
	},
	[9.3] = {
		"Update the 'damage to death' formula."
	}
}

-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- CHARACTERISTICS TABLE
ChoicesHelper.CharacteristicsID = {}
ChoicesHelper.CharacteristicsID[0] = "brutality"
ChoicesHelper.CharacteristicsID[1] = "finesse"
ChoicesHelper.CharacteristicsID[2] = "technology"
ChoicesHelper.CharacteristicsID[3] = "moxie"
ChoicesHelper.CharacteristicsID[4] = "insight"
ChoicesHelper.CharacteristicsID[6] = "focus recovery rate"
ChoicesHelper.CharacteristicsID[7] = "base health"
ChoicesHelper.CharacteristicsID[26] = "Physical Resistance"
ChoicesHelper.CharacteristicsID[40] = "grit"
ChoicesHelper.CharacteristicsID[35] = "assault power"
ChoicesHelper.CharacteristicsID[36] = "support power"
ChoicesHelper.CharacteristicsID[41] = "shield capacity"
ChoicesHelper.CharacteristicsID[42] = "armor"
ChoicesHelper.CharacteristicsID[32] = "strikethrough rating"
ChoicesHelper.CharacteristicsID[47] = "critical severity rating"
ChoicesHelper.CharacteristicsID[34] = "critical hit rating"
ChoicesHelper.CharacteristicsID[33] = "deflect rating"
ChoicesHelper.CharacteristicsID[43] = "deflect critical hit rating"
ChoicesHelper.CharacteristicsID[48] = "pvp offense rating"
ChoicesHelper.CharacteristicsID[49] = "pvp defense rating"

ChoicesHelper.ClassID = {}
ChoicesHelper.ClassID[0] = "Global"
ChoicesHelper.ClassID[1] = "Warrior"
ChoicesHelper.ClassID[2] = "Engineer"
ChoicesHelper.ClassID[3] = "Esper"
ChoicesHelper.ClassID[4] = "Medic"
ChoicesHelper.ClassID[5] = "Stalker"
ChoicesHelper.ClassID[7] = "Spellslinger"

ChoicesHelper.Spec = {}
ChoicesHelper.Spec[0] = "DPS"
ChoicesHelper.Spec[1] = "Healer"
ChoicesHelper.Spec[2] = "Tank"

ChoicesHelper.SelfClass = ""
ChoicesHelper.SelfClassID = 0
ChoicesHelper.selfSpecID = -1

ChoicesHelper.coefficient = {}
ChoicesHelper.coefficient.MainStat = 10
ChoicesHelper.coefficient.SecondStat = 7
ChoicesHelper.coefficient.ThirdStat = 5
ChoicesHelper.coefficient.leftOver = 0

ChoicesHelper.Specialization = {}
-- Global
ChoicesHelper.Specialization[0] = {}
ChoicesHelper.Specialization[0][0] = {}
ChoicesHelper.Specialization[0][0].ThirdStat = { 35, 32, 34, 47 }
ChoicesHelper.Specialization[0][1] = {}
ChoicesHelper.Specialization[0][1].ThirdStat = { 36, 34, 47, 6 }
ChoicesHelper.Specialization[0][2] = {}
ChoicesHelper.Specialization[0][2].ThirdStat = { 42, 41, 7, 43, 33 }
-- Warrior
ChoicesHelper.Specialization[1] = {} 
-- DPS
ChoicesHelper.Specialization[1][0] = {}
ChoicesHelper.Specialization[1][0].MainStat = { 0 }
ChoicesHelper.Specialization[1][0].SecondStat = { 3, 1 }
ChoicesHelper.Specialization[1][0].ThirdStat = { }
-- Tank
ChoicesHelper.Specialization[1][2] = {}
ChoicesHelper.Specialization[1][2].MainStat = { 2 }
ChoicesHelper.Specialization[1][2].SecondStat = { 4, 40 }
ChoicesHelper.Specialization[1][2].ThirdStat = { }
-- Spellslinger
ChoicesHelper.Specialization[7] = {}
-- DPS
ChoicesHelper.Specialization[7][0] = {}
ChoicesHelper.Specialization[7][0].MainStat = { 1 }
ChoicesHelper.Specialization[7][0].SecondStat = { 3, 0 }
ChoicesHelper.Specialization[7][0].ThirdStat = { }
-- Healer
ChoicesHelper.Specialization[7][1] = {}
ChoicesHelper.Specialization[7][1].MainStat = { 4 }
ChoicesHelper.Specialization[7][1].SecondStat = { 3, 0 }
ChoicesHelper.Specialization[7][1].ThirdStat = { }
-- Esper
ChoicesHelper.Specialization[3] = {}
-- DPS
ChoicesHelper.Specialization[3][0] = {}
ChoicesHelper.Specialization[3][0].MainStat = { 3 }
ChoicesHelper.Specialization[3][0].SecondStat = { 1, 0 }
ChoicesHelper.Specialization[3][0].ThirdStat = { }
-- Healer
ChoicesHelper.Specialization[3][1] = {}
ChoicesHelper.Specialization[3][1].MainStat = { 4 }
ChoicesHelper.Specialization[3][1].SecondStat = { 1, 0 }
ChoicesHelper.Specialization[3][1].ThirdStat = { }
-- Engineer
ChoicesHelper.Specialization[2] = {}
-- DPS
ChoicesHelper.Specialization[2][0] = {}
ChoicesHelper.Specialization[2][0].MainStat = { 1 }
ChoicesHelper.Specialization[2][0].SecondStat = { 3, 0 }
ChoicesHelper.Specialization[2][0].ThirdStat = { }
-- Tank
ChoicesHelper.Specialization[2][2] = {}
ChoicesHelper.Specialization[2][2].MainStat = { 2 }
ChoicesHelper.Specialization[2][2].SecondStat = { 4, 40 }
ChoicesHelper.Specialization[2][2].ThirdStat = { }
-- Stalker
ChoicesHelper.Specialization[5] = {}
-- DPS
ChoicesHelper.Specialization[5][0] = {}
ChoicesHelper.Specialization[5][0].MainStat = { 0 }
ChoicesHelper.Specialization[5][0].SecondStat = { 3, 1 }
ChoicesHelper.Specialization[5][0].ThirdStat = { }
-- Tank
ChoicesHelper.Specialization[5][2] = {}
ChoicesHelper.Specialization[5][2].MainStat = { 2 }
ChoicesHelper.Specialization[5][2].SecondStat = { 4, 40 }
ChoicesHelper.Specialization[5][2].ThirdStat = { }
-- Medic
ChoicesHelper.Specialization[4] = {}
-- DPS
ChoicesHelper.Specialization[4][0] = {}
ChoicesHelper.Specialization[4][0].MainStat = { 2 }
ChoicesHelper.Specialization[4][0].SecondStat = { 3, 0 }
ChoicesHelper.Specialization[4][0].ThirdStat = { }
-- Healer
ChoicesHelper.Specialization[4][1] = {}
ChoicesHelper.Specialization[4][1].MainStat = { 4 }
ChoicesHelper.Specialization[4][1].SecondStat = { 3, 0 }
ChoicesHelper.Specialization[4][1].ThirdStat = { }


ChoicesHelper.CharacterDataLines = {}

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function ChoicesHelper:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    return o
end

function ChoicesHelper:Init()
    Apollo.RegisterAddon(self, true)
end

function ChoicesHelper:InitValues()
	if self.config.global.Version == nil then
		self.config:ResetDB()
	end

	if self.config.global.Version == nil or self.config.global.Version < self.VERSION then
		self.config.global.PatchNotes = self:InitPatchNote(self.config.global.Version)
		self.config.global.Version = self.VERSION
	end
	if self.config.char.Version == nil or self.config.char.Version < self.VERSION then
		self.config.char.Version = self.VERSION
	end

	-- initialize variables here
	if self.config.char.SelfClassID == nil or self.config.char.SelfClassID == -1 then
		
		self.config.char.SelfClassID = -1
		if GameLib == nil or GameLib.GetPlayerUnit() == nil then
			return false
		end
		self.config.char.SelfClassID = GameLib.GetPlayerUnit():GetClassId()

		self.config.char.SelfClass = self.ClassID[self.config.char.SelfClassID]
		--SendVarToRover("self.config.char", self.config.char)
		

		self.config.char.secondSpecID = -1
		self.config.char.secondSpecName = ""
			
		for key,value in pairs(self.Specialization[self.config.char.SelfClassID]) do
			if key ~= 0 then 
				self.config.char.secondSpecID = key
				self.config.char.secondSpecName = self.Spec[key]
				--Print("Get Key " .. key .. ", name: " .. self.config.char.secondSpecName)
			end
		end
	end
	
	if self.config.char.ScoreOnAllItems == nil then
		self.config.char.ScoreOnAllItems = false
	end
	
	if self.config.char.Specializations == nil then self.config.char.Specializations = {} end
	
	if 	self.config.char.Specializations["DPS"] == nil then
		self.config.char.Specializations["DPS"] = self:updateSpecializationTable(self.config.char.SelfClassID, 0)
	end
	
	if self.config.char.Specializations[self.config.char.secondSpecName] == nil then
		self.config.char.Specializations[self.config.char.secondSpecName] = self:updateSpecializationTable(self.config.char.SelfClassID, self.config.char.secondSpecID)
	end
	
	if self.config.char.SelectedSpec == nil or self.config.char.Specializations[self.config.char.SelectedSpec] == nil then
		self.config.char.SelectedSpec = "DPS"
	end
	
	if not self.HaveCharacterWnd then
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Realm, "<ChoicesHelper> To see character information, you need to get the curse addon: CharacterInfoPlus")
		self.HaveCharacterWnd= true
	end

end

function ChoicesHelper:InitPatchNote(ActualVersion)
	local patchBuild = ""
	for k,v in pairs(self.VERSIONNOTES) do
		if ActualVersion  == nil or k > ActualVersion then
			for i,note in ipairs(self.VERSIONNOTES[k]) do
				patchBuild = patchBuild .. "- " .. note .. "\r\n"
			end
		end
	end
	return patchBuild
end

function ChoicesHelper:updateSpecializationTable(classID, specID)
		local specializationStat = {}
		--Print(">> ClassID: " .. classID .. ", spec: " .. specID)

		specializationStat = self.Specialization[classID][specID]
		specializationStat.ThirdStat = self.Specialization[0][specID].ThirdStat
		
		local exploitableStatCoef = {}
		for k,v in pairs(specializationStat.MainStat) do
			exploitableStatCoef[v] = self.coefficient.MainStat
		end
		
		for k,v in pairs(specializationStat.SecondStat) do
			exploitableStatCoef[v] = self.coefficient.SecondStat 
		end
		
		for k,v in pairs(specializationStat.ThirdStat) do
			exploitableStatCoef[v] = self.coefficient.ThirdStat 
		end
		
		return exploitableStatCoef;
end

-----------------------------------------------------------------------------------------------
-- ChoicesHelper OnLoad
-----------------------------------------------------------------------------------------------
function ChoicesHelper:OnLoad()

	Apollo.GetPackage("Gemini:Hook-1.0").tPackage:Embed(self)
	
	GeminiDB = Apollo.GetPackage("Gemini:DB-1.0").tPackage
	self.config = Apollo.GetPackage("Gemini:DB-1.0").tPackage:New(self)

    -- load our form file
	--self:InitValues()
	self.xmlDoc = XmlDoc.CreateFromFile("ChoicesHelper.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	
	
	-- tooltip content
	local ToolTipAddon = Apollo.GetAddon("ToolTips") or Apollo.GetAddon("VikingTooltips")
    self:PostHook(ToolTipAddon , "CreateCallNames")
	
end

-----------------------------------------------------------------------------------------------
-- ChoicesHelper OnDocLoaded
-----------------------------------------------------------------------------------------------
function ChoicesHelper:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "ChoicesHelperForm", nil, self)

		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
		self:initLocation()
		self.wndNameChoice = self.wndMain:FindChild("NameChoices")
		self.wndAddCharacteristic = self.wndMain:FindChild("AddCharacteristicForm")
		self.wndExportWindow = self.wndMain:FindChild("ExportWindow")
		self.wndImportWindow = self.wndMain:FindChild("ImportWindow")
		self.wndPatchNoteWindow = self.wndMain:FindChild("NewsUpdate")

		-- prepare window

		
		--self:UpdateSpecInfo()

		self.wndNameChoice:Show(false, true)
	    self.wndMain:Show(false, true)
		self.wndAddCharacteristic:Show(false, true)
		self.wndExportWindow:Show(false, true)
		self.wndImportWindow:Show(false, true)
		self.wndPatchNoteWindow:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		self.HaveCharacterWnd = self:InitCharacterWindow()
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("choiceshelpersettings", "OnChoicesHelperOn", self)
		Apollo.RegisterSlashCommand("chs", "OnChoicesHelperOn", self)


		-- Do additional Addon initialization here
		
	end
end

function ChoicesHelper:initLocation()
	if self.config.char.Position ~= nil then
		self.wndMain:SetAnchorOffsets(self.config.char.Position.left, self.config.char.Position.top, self.config.char.Position.right, self.config.char.Position.bottom)
	else 
		self.config.char.Position = {}
		self.config.char.Position.left, self.config.char.Position.top, self.config.char.Position.right, self.config.char.Position.bottom = self.wndMain:GetAnchorOffsets()
	end
end

-----------------------------------------------------------------------------------------------
-- ChoicesHelper Functions
-----------------------------------------------------------------------------------------------
---------------------
-- TOOLS FUNCTIONS --
---------------------

function ChoicesHelper:export(Name, coefficients)
	local result = "Name=" .. Name .. ";"

	for k, v in pairs(coefficients) do
		result = result .. k .. "=" .. v .. ";"
	end

	local result = self:enc(result)
	return result
end

function ChoicesHelper:import(hashCode)
	if hashCode == nil then return nil end
	hashCode = self:dec(hashCode)
	
	if hashCode == nil then return nil end

	local Blocks = string.gmatch(hashCode,"([a-z=A-Z0-9.-]*);")
	
	if Blocks == nil then return nil end
	
	local Name = string.match(hashCode,"Name=([a-zA-Z0-9]+);")
	
	if Name == nil then return nil end
	
	local result = {}
	local coefficients = {}
	for b in Blocks do
		local key, value = string.match(b,"([0-9.-]+)=([0-9.-]+)")
		key = tonumber(key)
		value = tonumber(value)
		if key ~= nil and value ~= nil then
			coefficients[key] = value
		end
	end
	
	if self:tablelength(coefficients) == 0 then return nil end
	
	result[Name] = coefficients
	return result
end

function ChoicesHelper:tablelength(T)
	local count = 0
	for _ in pairs(T) do count = count + 1 end
	return count
end


-----------
-----------
-----------

---------------------
------ BASE 64 ------
---------------------
-- character table string
local b='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'

-- encoding
function ChoicesHelper:enc(data)
    return ((data:gsub('.', function(x) 
        local r,b='',x:byte()
        for i=8,1,-1 do r=r..(b%2^i-b%2^(i-1)>0 and '1' or '0') end
        return r;
    end)..'0000'):gsub('%d%d%d?%d?%d?%d?', function(x)
        if (#x < 6) then return '' end
        local c=0
        for i=1,6 do c=c+(x:sub(i,i)=='1' and 2^(6-i) or 0) end
        return b:sub(c+1,c+1)
    end)..({ '', '==', '=' })[#data%3+1])
end

-- decoding
function ChoicesHelper:dec(data)
    data = string.gsub(data, '[^'..b..'=]', '')
    return (data:gsub('.', function(x)
        if (x == '=') then return '' end
        local r,f='',(b:find(x)-1)
        for i=6,1,-1 do r=r..(f%2^i-f%2^(i-1)>0 and '1' or '0') end
        return r;
    end):gsub('%d%d%d?%d?%d?%d?%d?%d?', function(x)
        if (#x ~= 8) then return '' end
        local c=0
        for i=1,8 do c=c+(x:sub(i,i)=='1' and 2^(8-i) or 0) end
        return string.char(c)
    end))
end

---------------------
---------------------
---------------------

---------------------------------------------------------------------------------------------------
-- Settings window 
---------------------------------------------------------------------------------------------------
function ChoicesHelper:OnConfigure()
	self:ShowMainWindow()
end

-- on SlashCommand "/choiceshelpersettings"
function ChoicesHelper:OnChoicesHelperOn(cmd, arg)
	if arg == nil or arg == "" then
		self:ShowMainWindow()
	else
		self:UpdateSpecializationChoice(arg, nil)
	end
end

function ChoicesHelper:ShowMainWindow()
	self:UpdateSpecInfo()
	self.wndMain:Invoke() -- show the window
end

function ChoicesHelper:ShowNameChoice(Target, callback)

	local data = self.wndNameChoice:GetData()
	if data == nil then data = {} end
	
	self.wndNameChoice:FindChild("EditBox"):SetMaxTextLength(10)
	
	if Target ~= nil then
		data.NameToEdit = Target
		self.wndNameChoice:FindChild("EditBox"):SetText(Target:GetText())
	else
		self.wndNameChoice:FindChild("EditBox"):SetText("Type Name")
		data.NameToEdit = nil
	end
	
	self.CallBack = callback
	self.wndNameChoice:SetData(data)
	self.wndNameChoice:Invoke()
	self.wndNameChoice:FindChild("EditBox"):SetFocus()
end

function ChoicesHelper:CreateCallNames(luaCaller)
	local origItemTooltip = Tooltip.GetItemTooltipForm
    Tooltip.GetItemTooltipForm = function(luaCaller, wndControl, item, bStuff, nCount)
		wndControl:SetTooltipDoc(nil)
		local wndTooltip, wndTooltipComp = origItemTooltip(luaCaller, wndControl, item, bStuff, nCount)
		if (wndTooltip ~= nil) and not item:IsCommodity() then

			--local itemID = item:GetItemId()
			local offset = 5
            			-- should compute score here			
			local result = self:buildComparaison(item)

			if result == nil then
				return wndTooltip, wndTooltipComp
			end
			
			local extra = Apollo.LoadForm(self.xmlDoc , "TooltipScore", wndTooltip, self)

			
			local diffText = ""
			if result.BETTER then
				extra:FindChild("ScoreValueLabel"):SetTextColor("green")
				diffText = "+"
			else
				extra:FindChild("ScoreValueLabel"):SetTextColor("red")
			end
			
			extra:FindChild("ScoreValueLabel"):SetText(result.SCORE .. " ("..diffText ..result.DIFFERENCE..")")
			-- position
			local eLeft, eTop, eRight, eBottom = extra:GetAnchorOffsets()
            local nLeft, nTop, nRight, nBottom = wndTooltip:GetAnchorOffsets()
            -- extra:SetAnchorOffsets(eLeft, nBottom - offset, nRight, nBottom + (eBottom - eTop - offset))
			--extra:SetAnchorOffsets(eLeft, eTop, eRight, nBottom + (eBottom - eTop - offset))

            --wndTooltip:SetAnchorOffsets(nLeft, nTop, nRight, nBottom + (eBottom - eTop - offset))
		end
		return wndTooltip, wndTooltipComp
	end
end

function ChoicesHelper:InitCharacterWindow()

	if AddCharacterInformationLine == nil then
		return false
	end
	self.CharacterDataLines = {}
	self.CharacterDataLines["Total Gear Score"] = AddCharacterInformationLine(
		"ChoicesHelper",
		"Total Gear Score",
		function() return self:getTotalGearScore(self) end,
		function() return "green" end, 
		nil,
		"Sum of all gear scores")
	
	self.CharacterDataLines["Base Damage"] = AddCharacterInformationLine(
		"ChoicesHelper",
		"Base Damage", 
		function() return self:computeBaseDamage(nil) end, 
		function() 
			if self.CharacterDataLines["Base Heal"] == nil or self.CharacterDataLines["Base Damage"] == nil then 
				return "white" 
			elseif self.CharacterDataLines["Base Heal"]:update() > self.CharacterDataLines["Base Damage"]:update() then
				return "red"
			else 
				return "green" 
			end
		end, 
		nil,
		"AP + AP x armorPierce + AP x shieldPierce + (AP x criticalSeverity) x criticalHitchance")
	self.CharacterDataLines["Base Heal"] = AddCharacterInformationLine("ChoicesHelper","Base Heal", function() return self:computeBaseHeal(nil) end, 
		function() 
			if self.CharacterDataLines["Base Damage"] == nil or self.CharacterDataLines["Base Heal"] == nil then 
				return "white" 
			elseif self.CharacterDataLines["Base Damage"]:update() > self.CharacterDataLines["Base Heal"]:update() then
				return "red"
			else 
				return "green" 
			end
		end, 
		nil,
		"SP + (SP x criticalSeverity) x criticalHitchance")
	self.CharacterDataLines["Damage to Death"] = AddCharacterInformationLine(
		"ChoicesHelper",
		"Damage to Death", 
		function() return self:computeDamageToDeath(nil) end, 
		nil, 
		nil,
		"(Health+Shield) * (1 / (1-rez)) * (1 / (1-dodge)) * (1 / (1-critdodge))")
	return true
end

function ChoicesHelper:UpdateGlobalGearScore()
	for k, v in pairs(self.CharacterDataLines) do
		self:UpdateCharacterInformation(v)
	end
end

function ChoicesHelper:UpdateCharacterInformation(charInfo)
	charInfo:forceUpdate()
end

function ChoicesHelper:buildComparaison(item)
	if item == nil then
		 return nil 
	end
	if GameLib == nil or  GameLib.GetPlayerUnit() == nil then
		return nil 
	end
	
	local selfPlayer = GameLib.GetPlayerUnit()
	self:InitValues()
	--SendVarToRover("player", selfPlayer)
	-- GetClassId 
	-- 7 Spellslinger
	
	
	-- slot ID
	local slot = item:GetSlot()

	local scoreItem = self:computeScore(item)
	
	if scoreItem == nil then return nil end
	
	local better = true
	local difference = 0
	
	-- GetEquippedItems
	local itemsEquipped = selfPlayer:GetEquippedItems()
	for key, value in pairs(itemsEquipped) do
	
		if(value == item) then
			break
		end
		
		local thisSlot = value:GetSlot()
		if thisSlot == slot then
			local thisScoreItem = self:computeScore(value)
			better = scoreItem >= thisScoreItem
			difference = scoreItem - thisScoreItem
			break
		end
		
	end
	
	return {
		BETTER = better,
	 	SCORE = scoreItem,
		DIFFERENCE = difference
	}
end

function ChoicesHelper:getTotalGearScore(self)
	local selfPlayer = GameLib.GetPlayerUnit()
	--SendVarToRover("Player",selfPlayer)
	local itemsEquipped = selfPlayer:GetEquippedItems()
	local TotalScore = 0
	for key, value in pairs(itemsEquipped) do
		local s = self:computeScore(value)
		if s ~= nil and s > 0 then
			TotalScore = TotalScore + s
		end
	end
	
	return TotalScore
end

function ChoicesHelper:getCharacterStats(playerTarget)
	local selfPlayer
	if playerTarget == nil then
		selfPlayer = GameLib:GetPlayerUnit()
	else
		selfPlayer = playerTager
	end
	
	local Characteristics = {}

	Characteristics['assaultPower'] = selfPlayer:GetAssaultPower()
	Characteristics['supportPower'] = selfPlayer:GetSupportPower() 
	Characteristics['maxHealth'] = selfPlayer:GetMaxHealth()
	Characteristics['maxFocus'] = selfPlayer:GetMaxMana()
	Characteristics['maxShield'] = selfPlayer:GetShieldCapacityMax()
	-- Characteristics['armor'] = selfPlayer: go to physical mitigation
	Characteristics['strikethroughChance'] = selfPlayer:GetStrikethroughChance()
	Characteristics['criticalHitChance'] = selfPlayer:GetCritChance()
	Characteristics['criticalSeverity'] = selfPlayer:GetCritSeverity()
	Characteristics['armorPierce'] = selfPlayer:GetIgnoreArmorBase()
	Characteristics['shieldPierce'] = selfPlayer:GetIgnoreShieldBase()
	Characteristics['lifesteal'] = selfPlayer:GetBaseLifesteal()
	Characteristics['coldDownReduc'] = selfPlayer:GetCooldownReductionModifier()
	Characteristics['shieldRegen'] = selfPlayer:GetShieldRegenPct() -- percent per tick
	Characteristics['shieldRebootTime'] = selfPlayer:GetShieldRebootTime() -- in ms
	Characteristics['physicalResistance'] = selfPlayer:GetPhysicalMitigation()
	Characteristics['techResistance'] = selfPlayer:GetTechMitigation()
	Characteristics['magicResistance'] = selfPlayer:GetMagicMitigation()
	Characteristics['deflectChance'] = selfPlayer:GetDeflectChance()
	Characteristics['deflectCritChance'] = selfPlayer:GetDeflectCritChance()
	Characteristics['CCResiliance'] = selfPlayer:GetCCDurationModifier()
	Characteristics['focusRecoveryRateInCombat'] = selfPlayer:GetManaRegenInCombat()
	Characteristics['focusRecoveryRateOutCombat'] = selfPlayer:GetManaRegenNonCombat()
	Characteristics['focusCostReduction'] = selfPlayer:GetManaCostModifier()
	Characteristics['pvpOffense'] = selfPlayer:GetPvPOffensePercent()
	Characteristics['pvpDefense'] = selfPlayer:GetPvPDefensePercent()
	Characteristics['pvpOffenseRating'] = selfPlayer:GetPvPOffenseRating()
	Characteristics['pvpDefenseRating'] = selfPlayer:GetPvPDefenseRating()

	return Characteristics
end

function ChoicesHelper:computeBaseDamage(targetplayer)
	local Characteristics = self:getCharacterStats(targetplayer)
	local damage = Characteristics['assaultPower'] 
	+ (Characteristics['assaultPower'] * Characteristics['criticalSeverity']) * Characteristics['criticalHitChance'] 
	+ Characteristics['assaultPower'] * Characteristics['armorPierce']
	+ Characteristics['assaultPower'] * Characteristics['shieldPierce']
	
	return self:round(damage, 0)
end

function ChoicesHelper:computeBaseHeal(targetplayer)
	local Characteristics = self:getCharacterStats(targetplayer)
	local heal = Characteristics['supportPower'] 
	+ (Characteristics['supportPower'] * Characteristics['criticalSeverity']) * Characteristics['criticalHitChance'] 

	return self:round(heal, 0)
end

function ChoicesHelper:computeDamageToDeath(targetplayer)
	local Characteristics = self:getCharacterStats(targetplayer)
	local totalH = Characteristics['maxHealth'] + Characteristics['maxShield']
	
	local health = totalH 
			* (1 / ( 1 - Characteristics['physicalResistance']))
			* (1 / ( 1 - Characteristics['deflectChance']))
			* (1 / ( 1 - Characteristics['deflectCritChance']))

	-- totalH + 
	--	Characteristics['physicalResistance'] * totalH + 
	--	totalH * Characteristics['deflectChance'] +
	--	totalH * Characteristics['deflectCritChance']
	return self:round(health, 0)
end

function ChoicesHelper:computeScore(item)
	if item == nil or item:IsCommodity() then
		return nil
	end
	if (not self.config.char.ScoreOnAllItems and (not item:CanEquip() or not item:IsEquippable())) then
		return nil
	end
	
	self:InitValues()
	local Score = 0
		
	-- get item characteristic
	local characteristics = self:extractItemInfo(item)
	
	for key, value in pairs(characteristics) do
		local coef = self.coefficient.leftOver
		if(self.config.char.Specializations[self.config.char.SelectedSpec][key] ~= nil) then
			coef = self.config.char.Specializations[self.config.char.SelectedSpec][key]
		end
		Score = Score + (value * coef)
	end
	
	return self:round(Score, 0)
end

function ChoicesHelper:extractItemInfo(item)
	local fullInfo = item:GetDetailedInfo();
	local bonuses = fullInfo.tPrimary.arBudgetBasedProperties
	local innateProp = fullInfo.tPrimary.arInnateProperties
	--SendVarToRover("bonuses", bonuses )
	--SendVarToRover("innateProp", innateProp )

	local Verbose = false
	
	local characteristics = {}
	for key, value in pairs(self.CharacteristicsID) do
		characteristics[key] = 0
	end
	
	if innateProp ~= nil then 
		for key, value in pairs(innateProp) do
			local propName = value.eProperty
			local propValue = value.nValue
			if Verbose then
				Print(propName .. ": " .. propValue)
			end
			
			characteristics[propName] = characteristics[propName] + propValue
		end
	end
	
	if(bonuses ~= nil) then
		for key, value in pairs(bonuses) do
			local propName = value.eProperty
			local propValue = value.nValue
			if Verbose then
				Print(propName .. ": " .. propValue)
			end
			if characteristics[propName] == nil then
				Print("A value of a characteristic of this item is " .. 
				propValue .. ", but we dont have it in the Database, could you look at your item and tell me the name of this characteritic and tell me that the index is " ..
				propName .. ", THANKS !")
			else
				characteristics[propName] = characteristics[propName] + propValue
			end
		end
	end
	
	return characteristics
end

function ChoicesHelper:round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

----------------------------------------------------------------------------------------------
-- ChoicesHelperForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function ChoicesHelper:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function ChoicesHelper:OnCancel()
	self:CloseAllPopUp()
	self.wndMain:Close() -- hide the window
end

function ChoicesHelper:CloseAllPopUp()
	self.wndNameChoice:Show(false)
	self.wndAddCharacteristic:Show(false)
	self.wndExportWindow:Show(false)
	self.wndImportWindow:Show(false)
	self.wndPatchNoteWindow:Show(false)
end

function ChoicesHelper:ClearContainer(container)
	local kids = container:GetChildren()
	container:SetData(nil)
	for k,v in pairs(kids) do
		v:Destroy()
	end
end

function ChoicesHelper:OnAddCharacteristics( wndHandler, wndControl, eMouseButton )
	if not self:CanClick() then
		Print("ERROR Finish editing first !")
	else
		self:OpenAddCharacteristic()
	end
end

function ChoicesHelper:OpenAddCharacteristic()
	self.wndAddCharacteristic:Invoke()
	self.wndAddCharacteristic:FindChild("DropboxButton"):SetData(nil)
	self.wndAddCharacteristic:FindChild("DropboxButton"):SetText("__Pick a Characteristic__")
	self.wndAddCharacteristic:FindChild("InputValueAddCharacteristicsChoice"):SetText("0")
end

function ChoicesHelper:AddCharacteristics(ID, Value)
	Value = tonumber(Value)
	
	if Value == nil then 
		Print("ERROR: Invalid value")
		return false 
	end
	if self.CharacteristicsID[ID] == nil then
		Print("ERROR: Invalid Characteristic")
	 	return false 
	end
	
	local Container = self.wndMain:FindChild("CharacteristicsContainer")
	local bigData = Container:GetData()

	if bigData == nil then
		bigData = {}
		bigData.CharacteristicID = {}
	end
	
	if bigData.CharacteristicID[ID] == nil then
		local wndLine = Apollo.LoadForm(self.xmlDoc, "CharacteristicsLine", Container, self)
		local data = wndLine:GetData()
	
		if data == nil then
			data = {}
		end
		self.config.char.Specializations[self.config.char.SelectedSpec][ID] = Value
		data.CharacteristicID = ID
		bigData.CharacteristicID[ID] = true
		wndLine:SetData(data)
		wndLine:FindChild("CharacteristicTitle"):SetText(self.CharacteristicsID[ID])
		wndLine:FindChild("InputValueCharacteristics"):SetText(Value)
		Container:SetData(oData)
		Container:SetData(bigData)
		Container:ArrangeChildrenVert()
		return true
	else
		Print("ERROR: Cannot add twice: " .. self.CharacteristicsID[ID] )
		return false
	end
end

function ChoicesHelper:AddSpec(Name, check)
	local Container = self.wndMain:FindChild("ListSpecSetContainer")
	local wndLine = Apollo.LoadForm(self.xmlDoc, "SpecLine", Container, self)
	wndLine:FindChild("SpecTitle"):SetText(Name)
	Container:SetData(oData)
	Container:ArrangeChildrenVert()
 
	if check then
		self:UpdateSpecializationChoice(Name, wndLine:FindChild("SpecBtnLine"))
	else
		wndLine:FindChild("SpecBtnLine"):SetCheck(check)
	end
end

function ChoicesHelper:UpdateSpecInfo()
	self:InitValues()
	
	self:ClearContainer(self.wndMain:FindChild("ListSpecSetContainer"))
	self:ClearContainer(self.wndMain:FindChild("CharacteristicsContainer"))


	for key, value in pairs(self.config.char.Specializations) do
		if value ~= nil then
			local isSelected = (key == self.config.char.SelectedSpec)
			self:AddSpec(key, isSelected)
		end
	end
	
	self.wndMain:FindChild("CheckShowScoreAll"):SetCheck(self.config.char.ScoreOnAllItems)
	
	self:ShowPatchNote()
end

local NameToEdit = nil
function ChoicesHelper:OnNewSpec( wndHandler, wndControl, eMouseButton )
	if not self:CanClick() then
		Print("ERROR: Finish editing first !")
	else
		self:ShowNameChoice(nil, self.UpdateSpecName)
	end
end

function ChoicesHelper:OnRenameSpec( wndHandler, wndControl, eMouseButton )
	if not self:CanClick() then
		Print("ERROR: Finish editing first !")
	else
		local itemtToRename = self:getSelectedSpec()
		-- SpecTitle
		if itemtToRename == nil then return end
		self:ShowNameChoice(itemtToRename:FindChild("SpecTitle"), self.UpdateSpecName)
	end
end

function ChoicesHelper:OnCloneSpec( wndHandler, wndControl, eMouseButton )
	if not self:CanClick() then
		Print("ERROR: Finish editing first !")
	else
		self:ShowNameChoice(nil, self.CloneSpecName)
	end
end

function ChoicesHelper:CanClick()
	return not self.wndNameChoice:IsShown() 
	and not self.wndAddCharacteristic:IsShown() 
	and not self.wndExportWindow:IsShown() 
	and not self.wndImportWindow:IsShown()
	and not self.wndPatchNoteWindow:IsShown()
end

function ChoicesHelper:OnCancelPopUpWindow( wndHandler, wndControl, eMouseButton )
	self:CloseAllPopUp()
end

function ChoicesHelper:OnExportSpec( wndHandler, wndControl, eMouseButton )
	if not self:CanClick() then
		Print("ERROR: Finish editing first !")
	else
	
		local CODE = self:export(self.config.char.SelectedSpec,
			self.config.char.Specializations[self.config.char.SelectedSpec]
			)
		self.wndExportWindow:FindChild("CopyBox"):SetText(CODE)
		self.wndExportWindow:FindChild("BtnCopyClipboard"):SetActionData(GameLib.CodeEnumConfirmButtonType.CopyToClipboard, CODE)	
		self.wndExportWindow:Show(true)
		self.wndExportWindow:FindChild("CopyBox"):SetFocus()
	end
end

function ChoicesHelper:OnImportSpec( wndHandler, wndControl, eMouseButton )
	if not self:CanClick() then
		Print("ERROR: Finish editing first !")
	else
		self.wndImportWindow:FindChild("PasteBox"):SetText("[Paste your Code]")
		self.wndImportWindow:Show(true)
		self.wndImportWindow:FindChild("PasteBox"):SetFocus()
	end
end

function ChoicesHelper:OnAddNewCodePasted( wndHandler, wndControl, eMouseButton )
	local Code = self.wndImportWindow:FindChild("PasteBox"):GetText()
	local item = self:import(Code)
	if item == nil then 
		Print("Invalid Code")
		self.wndImportWindow:FindChild("PasteBox"):SetText("[Paste your Code]")
		return
	end
	local name = ""
	for k , v in pairs(item) do
		name = k
	end

	if self.config.char.Specializations[name] ~= nil then
		local i = 0
		while true do
			if self.config.char.Specializations[name .. i] == nil then
				self.config.char.Specializations[name .. i] = item[name]
				break
			end
			i = i + 1
		end
	else
		self.config.char.Specializations[name] = item[name]
	end
	
	self.wndImportWindow:Show(false)
	self:OnChoicesHelperOn()
end

function ChoicesHelper:OnFilteringName( wndHandler, wndControl, strText )
	local name = string.match(wndControl:GetText(),"([a-zA-Z0-9]+)")
	if name ~= nil and wndControl:GetText() ~= nil and string.len(name) ~= string.len(wndControl:GetText()) then 
		wndControl:SetText(name)
	end
end

function ChoicesHelper:OnPatchSeen( wndHandler, wndControl, eMouseButton )
	self.config.global.PatchNotes = nil
	self:CloseAllPopUp()
end

function ChoicesHelper:ShowPatchNote()
	if self.config.global.PatchNotes ~= nil then
		self.wndPatchNoteWindow:FindChild("PatchContent"):SetText(self.config.global.PatchNotes)
		self.wndPatchNoteWindow:Show(true)
	end
end	

function ChoicesHelper:OnScoreAllItemChanged( wndHandler, wndControl, eMouseButton )
	self.config.char.ScoreOnAllItems = wndControl:IsChecked()
end

function ChoicesHelper:OnMainWindowSizeUpdate( wndHandler, wndControl )
	if self.config.char.Position == nil then
		self.config.char.Position = {}
	end
	self.config.char.Position.left, self.config.char.Position.top, self.config.char.Position.right, self.config.char.Position.bottom =  self.wndMain:GetAnchorOffsets()
end

---------------------------------------------------------------------------------------------------
-- CharacteristicsLine Functions
---------------------------------------------------------------------------------------------------

function ChoicesHelper:OnCharacteristicValueChange( wndHandler, wndControl, strText ) 
	if strText == "." then
		strText = "0."
		wndControl:SetText("0.")
		wndControl:SetSel(2,0,0,0)
	end
	
	local newValue = tonumber(strText)
	if newValue == nil then
		wndControl:SetText("NaN")
	else
		local ID = wndControl:GetParent():GetData().CharacteristicID
		self.config.char.Specializations[self.config.char.SelectedSpec][ID] = newValue
		self:UpdateGlobalGearScore()
	end
end

function ChoicesHelper:OnDeleteCharacteristic( wndHandler, wndControl, eMouseButton )
	local ID = wndControl:GetParent():GetData().CharacteristicID
	self.wndMain:FindChild("CharacteristicsContainer"):GetData().CharacteristicID[ID] = nil
	self.config.char.Specializations[self.config.char.SelectedSpec][ID] = nil
	self:UpdateGlobalGearScore()
	local Container = self.wndMain:FindChild("CharacteristicsContainer")
	wndControl:GetParent():Destroy()
	Container:ArrangeChildrenVert()
end

---------------------------------------------------------------------------------------------------
-- SpecLine Functions
---------------------------------------------------------------------------------------------------

function ChoicesHelper:OnSelectSpec( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	local SpecName = wndControl:FindChild("SpecTitle"):GetText()
	self:UpdateSpecializationChoice(SpecName, nil)
end

function ChoicesHelper:getSelectedSpec()
	local container = self.wndMain:FindChild("ListSpecSetContainer")
	--SendVarToRover("btns",container:GetChildren())
	for i, w in ipairs(container:GetChildren()) do
		local btn = w:FindChild("SpecBtnLine")
        if btn:IsChecked() then
          return btn
        end
    end
end

function ChoicesHelper:UpdateSpecName(previousName, newName)
	if self.config.char.Specializations[newName] ~= nil then
		Print("ERROR: Name '" .. newName .. "' already exist ! <ERROR>")
		return false
	end
	if self.config.char.Specializations[previousName] == nil then
		self.config.char.Specializations[newName] = {}
	else
		self.config.char.Specializations[newName] = self.config.char.Specializations[previousName]
		self.config.char.Specializations[previousName] = nil
	end
	
	return true
end

function ChoicesHelper:CloneSpecName(previousName, newName)
	if self.config.char.Specializations[newName] ~= nil then
		Print("ERROR: Name '" .. newName .. "' already exist ! <ERROR>")
		return false
	end
	
	Print("Cloning specialization '" .. self.config.char.SelectedSpec .. "'.")
	self.config.char.Specializations[newName] = {}
	for j,x in pairs(self.config.char.Specializations[self.config.char.SelectedSpec]) do
		self.config.char.Specializations[newName][j] = x 
	end
		
	return true
end

function ChoicesHelper:OnDeleteSpec( wndHandler, wndControl, eMouseButton )
	local parent = wndControl:GetParent()
	local SpecName = wndControl:GetParent():FindChild("SpecTitle"):GetText()
	if self.config.char.SelectedSpec == SpecName or wndControl:GetParent():FindChild("SpecBtnLine"):IsChecked()  then
		Print("ERROR: Cannot Delete actually used Specialization")
	else
		self.config.char.Specializations[SpecName] = nil
		parent:Destroy()
		self.wndMain:FindChild("ListSpecSetContainer"):ArrangeChildrenVert()
	end
end

function ChoicesHelper:UpdateSpecializationChoice(newSpec, checkBox)
	if self.config.char.Specializations[newSpec] == nil then
		Print("ERROR: Cannot switch to spec '" .. newSpec .. ". because it doesnt exist !")
		return false
	end
	
	self.config.char.SelectedSpec = newSpec
	Print("Switch specialization to: " .. self.config.char.SelectedSpec)
	
	self:UpdateGlobalGearScore()

	if self.wndMain:IsShown() or checkBox ~= nil then
		if checkBox ~= nil then
			self:UncheckAll()
			checkBox:SetCheck(true)
		elseif self.wndMain:IsShown() then
			self:UncheckAll()
			self:getSpecCheckBox(newSpec):SetCheck(true)
		end
	
		self:ClearContainer(self.wndMain:FindChild("CharacteristicsContainer"))
	
		for key, value in pairs(self.config.char.Specializations[newSpec]) do
			self:AddCharacteristics(key, value)
		end
	end
end

function ChoicesHelper:getSpecCheckBox(specName)
	local SpecLines = self.wndMain:FindChild("SpecSetContainer"):FindChild("ListSpecSetContainer"):GetChildren()
	for k,v in pairs(SpecLines) do
		local name = v:FindChild("SpecBtnLine"):FindChild("SpecTitle"):GetText()
		if name == specName then 
			return v:FindChild("SpecBtnLine")
		end
	end
	
	return nil
end

---------------------------------------------------------------------------------------------------
-- NameChoices Functions
---------------------------------------------------------------------------------------------------

function ChoicesHelper:OnValidateName( wndHandler, wndControl, eMouseButton )
	local NameSaved = self.wndNameChoice:FindChild("EditBox"):GetText()
	--Print("Get Text '" .. NameSaved .. "'")
	local previousName = ""
	
	local data = self.wndNameChoice:GetData()

	if data.NameToEdit ~= nil then
		previousName = data.NameToEdit:GetText()
	end

	if self:CallBack(previousName, NameSaved) then
		if  data.NameToEdit == nil then
			self:AddSpec(NameSaved, true)
		else
			data.NameToEdit:SetText(NameSaved)
			self:UpdateSpecializationChoice(NameSaved, data.NameToEdit:GetParent())
		end
		
		self.wndNameChoice:Show(false, true)
	end
end

function ChoicesHelper:UncheckAll()
	for i, w in ipairs(self.wndMain:FindChild("ListSpecSetContainer"):GetChildren()) do
		local btn = w:FindChild("SpecBtnLine")
	    btn:SetCheck(false)
	end
end

---------------------------------------------------------------------------------------------------
-- AddCharacteristicForm Functions
---------------------------------------------------------------------------------------------------

function ChoicesHelper:OnDropDownCharacteristicChanged( wndHandler, wndControl, eMouseButton )
	local Container = self.wndAddCharacteristic:FindChild("CharacteristicChoicesDropContainer")
	if Container:IsShown() then
		Container:Show(false)
	else
		local distContainer = self.wndMain:FindChild("CharacteristicsContainer")
		local bigData = distContainer:GetData()
		if bigData == nil or bigData.CharacteristicID == nil then
			bigData = {}
			bigData.CharacteristicID = {}
		end
		self:ClearContainer(self.wndAddCharacteristic:FindChild("CharacteristicChoicesDropContainer"))
		for k,v in pairs(self.CharacteristicsID) do
			if bigData.CharacteristicID[k] == nil then
				self:AddLineCharacteristicChoice(k)
			end
		end
		Container:Invoke()
	end
end

function ChoicesHelper:OnValidateAddCharacteristic( wndHandler, wndControl, eMouseButton )
	local ID = wndControl:GetParent():FindChild("DropboxButton"):GetData().CharacteristicID
	local Value = wndControl:GetParent():FindChild("InputValueAddCharacteristicsChoice"):GetText()
	if self:AddCharacteristics(ID, Value) then
		self.wndAddCharacteristic:Show(false, true)
	end
end

function ChoicesHelper:AddLineCharacteristicChoice(ID)
	local Container = self.wndAddCharacteristic:FindChild("CharacteristicChoicesDropContainer")
	local wndLine = Apollo.LoadForm(self.xmlDoc, "CharacteristicChoiceLine", Container, self)
	local data = wndLine:GetData()
	
	if data == nil then
		data = {}
	end
	data.CharacteristicID = ID
	wndLine:SetData(data)
	wndLine:SetText(self.CharacteristicsID[ID])

	Container:SetData(oData)
	Container:ArrangeChildrenVert()
end

function ChoicesHelper:OnCharacteristicChoiceSelected( wndHandler, wndControl, eMouseButton )
	local ID = wndControl:GetData().CharacteristicID
	local Name = wndControl:GetText()
	local Container = self.wndAddCharacteristic:FindChild("CharacteristicChoicesDropContainer")
	Container:Show(false)
	local SelectControl = self.wndAddCharacteristic:FindChild("DropboxButton")
	local data = SelectControl:GetData()
	if data == nil then
		data = {}
	end
	data.CharacteristicID = ID
	SelectControl:SetText(Name)
	SelectControl:SetData(data)
end

function ChoicesHelper:OnCharacteristicChoiceValueChange( wndHandler, wndControl, strText )
	if strText == "." then
		strText = "0."
		wndControl:SetText("0.")
		wndControl:SetSel(2,0,0,0)
	end
	
	local newValue = tonumber(strText)
	if newValue == nil then
		wndControl:SetText("NaN")
	end
end
---------------------------------------------------------------------------------------------------
-- CharacterMoreInfosForm Functions
---------------------------------------------------------------------------------------------------

function ChoicesHelper:onToggleMoreScoresWindow( wndHandler, wndControl, eMouseButton )
	wndControl:GetParent():FindChild("MoreInfoRegion"):Show(wndControl:IsChecked())
end

-----------------------------------------------------------------------------------------------
-- ChoicesHelper Instance
-----------------------------------------------------------------------------------------------
local ChoicesHelperInst = ChoicesHelper:new()
ChoicesHelperInst:Init()

